Subject: Re: atl1: use magic packet wake-on-lan only

From: Chris Snook <[email-masked]>
Date: Wed, 12 Nov 2008 12:37:00 -0500

J. K. Cliburn wrote:
> On Mon, 10 Nov 2008 13:42:25 -0500
> Chris Snook <[email-masked]> wrote:
> 
>> J. K. Cliburn wrote:
>>> atl1: use magic packet wake-on-lan only
>>>
>>> Of the various WOL options provided in include/linux/ethtool.h, the
>>> L1 NIC supports only magic packet.  Remove all options except magic
>>> packet from the atl1 driver.
>> Technically, we could implement the rest via the programmable 
>> pattern-matching hardware, but that would be an immense amount of
>> work.
> 
> Thanks for the pointer to the pattern matching capability.  I had
> forgotten about it.
> 
> What prompted the patch was a user asking some questions off-list about
> the L1 and WOL, and I realized the atl1 driver was advertising WOL
> options that weren't implemented.
> 
> I think the magic-packet-only patch I submitted to Jeff is still
> relevant, but I'm going to explore the pattern matching capability and
> see if we can implement some additional WOL options.  IMHO, though,
> those should be provided in a separate (future) patch.  Do you agree?
> 
> Jay

Completely.  Programming the pattern matching hardware is a lot more 
involved than setting a single bit in the hardware.

Are there any other NICs that have pattern-matching WoLAN capability? 
If so, how do their drivers take advantage of them?  If it turns out to 
be a widely underutilized feature, it might make sense to let ethtool do 
the dirty work.

-- Chris